﻿using System;
using System.Text.RegularExpressions;

namespace coordinates
	{
	public static class CoordinateHelper
		{
		public static double? TryParseCoord(string val, string positiveDir, string negativeDir)
			{
			double dec;
			Regex regex = new Regex("^(\\d+)[° ](\\d+)'(\\d+)\"([WNESwnes])$");
			if (double.TryParse(val, out dec))
				{
				return dec;
				} else if (regex.IsMatch(val))
				{
				Match m = regex.Match(val);
				int deg = int.Parse(m.Groups[1].Captures[0].Value);
				int min = int.Parse(m.Groups[2].Captures[0].Value);
				int sec = int.Parse(m.Groups[3].Captures[0].Value);
				string dir = m.Groups[4].Captures[0].Value;
				if (deg >= 0 && deg <= 180 && min >= 0 && min < 60 && sec >= 0 && sec < 60 && (dir == positiveDir || dir == negativeDir))
					return ((double)deg + (min / 60.0) + (sec / 3600.0)) * (dir == positiveDir ? 1 : -1);
				else
					return null;
				} else
				{ 
				return null; 
				}
			}

		public static string ToDMS(double val, string positiveDir, string negativeDir)
			{
			double pval = Math.Abs(val);
			int deg = (int)pval;
			int min = (int)((pval - deg) * 60);
			int sec = (int)((((pval - deg) * 60) - min) * 60);
			return String.Format("{0}°{1}'{2}\"{3}",deg,min,sec,((val < 0) ? negativeDir : positiveDir));
			}
		}
	}

