﻿<%@ Page Language="C#" %>
<!DOCTYPE html>
<html>
<head>
	<title>Coordinates calculation</title>
	<meta charset="utf-8">
	<style type="text/css">
	.formfield label {
	display: inline-block;
	width: 20em;
	border-bottom: solid thin black;
	overflow: hidden;
}

.formfield label:after {
	content:  "→";
	float: right;
}

.formfield { display: block;}

.formfield .error {
	border: solid thick red;
}
	</style>
</head>
<body>
<%
string lon_str=Request.Params?["lon"] ?? "";
string lat_str=Request.Params?["lat"] ?? "";
double? lon = coordinates.CoordinateHelper.TryParseCoord(lon_str, "E", "W");
double? lat = coordinates.CoordinateHelper.TryParseCoord(lat_str, "N", "S");
%>
	<form id="coord-form" action="">
	<span class="formfield"><label for="lat">Latitude: </label><input type="text" name="lat" id="lat" value="<%:lat_str%>">
	<% if((lon_str!=null || lat_str!=null) && !lat.HasValue ){ %>
	<span class="error">Incorrect format!!</span>
	<% } %>
	</span>
	<span class="formfield"><label for="lon">Longitude: </label><input type="text" name="lon" id="lon" value="<%:lon_str%>">
	<% if((lon_str!=null || lat_str!=null) && !lon.HasValue ){ %>
	<span class="error">Incorrect format!!</span>
	<% } %>
	</span>
	<button type="submit">Convert coordinates</button>
	</form>
	<% if(lon.HasValue && lat.HasValue) { %>
	<section>
	<h1>Converted coordinates</h1>
	<h2>Decimal format</h2>
	<p>lat: <%=lat.Value%>, lon: <%=lon.Value%></p>
	<h2>deg-min-sec format</h2>
	<p><%=coordinates.CoordinateHelper.ToDMS(lat.Value,"N","S")%>
	<%=coordinates.CoordinateHelper.ToDMS(lon.Value,"E","W")%></p>
	</section>
	<% } %>
</body>
</html>
